#!/usr/local/bin/perl

$BASE_DIR = "users/";

$QueryString = $ENV{QUERY_STRING};

@NameValuePairs = split (/&/, $QueryString);

foreach $NameValue (@NameValuePairs) {
  ($Name, $Value) = split (/=/, $NameValue);
  $Value =~ tr/+/ /;
  $Value =~ s/%([\dA-Fa-f][\dA-Fa-f])/ pack ("C",hex ($1))/eg;
  $Form{$Name} = $Value;
}

$user = $ENV{"REMOTE_USER"};
$BASE_DIR = "${BASE_DIR}${user}/";

# Split the path for the current category
@category_list = split (/\//, $Form{path});

# Read the global config file into Config_global
&parse_config_file ("$BASE_DIR$category_list[0].config", \%Config_global);

# Read the local config file into Config_local
&parse_config_file ("$BASE_DIR$Form{path}\/config", \%Config_local);

$temp = $Form{category};

if ( $temp !~ /^[a-zA-Z]+([a-zA-Z0-9 _-]*[a-zA-Z0-9]+)*$/ ) {
    print "Content-type: text/html", "\n\n";
    print "<B>ERROR</B><BR>Please use only letters, spaces, underscores and hyphens in the category name.<BR>Also, the name should start and end with a letter<BR>";
    exit(0);
}

$temp = "$BASE_DIR$Form{path}\/$Form{category}";
$output = `ls \"$temp\/*\"`;

if ($output eq "") {
  $output = `mkdir \"$temp\"`;
  if ($Config_global{"inherit_config"} == 1) {
      $temp = "\"$BASE_DIR$Form{path}\/config\" \"$BASE_DIR$Form{path}\/$Form{category}\/\"";
  } else {
      $temp1 = $Config_global{"default_config"};
      $temp = "\"$temp1\" \"$BASE_DIR$Form{path}\/$Form{category}\/config\"";
  }
  $output = `cp $temp`;
} else {
  print "Content-type: text/html", "\n\n";
  print "<B>ERROR</B><BR>Could not create category $Form{category}";
  exit(0);
}

$the_path = "$Form{\"path\"}\/$Form{\"category\"}";
$the_path =~ tr/ /+/;
print "Location: display.pl?path=$the_path", "\n\n";


sub parse_config_file {

local ($config_line, $Name, $Value, $Config);

$Config = $_[1];

if (!open (CONFIG, "$_[0]")) {
  print "<B>ERROR</B><BR>Config file not found : $_[0]";
  exit(0);
}

while (<CONFIG>) {
    $config_line=$_;
    chop ($config_line);
    $config_line =~ s/^\s*//;
    $config_line =~ s/\s*$//;
    if ( ($config_line !~ /^#/) && ($config_line ne "") ){
        ($Name, $Value) = split (/=/, $config_line);
        $$Config{$Name} = $Value;
    }
}

close(CONFIG);

}


