#!/usr/local/bin/perl

$BASE_DIR = "users/";

if($ENV{'REQUEST_METHOD'} eq "POST") {
  $type = "data_received";
  read(STDIN, $QueryString, $ENV{'CONTENT_LENGTH'});
} else {
  $type = "display_form";
  $QueryString = $ENV{QUERY_STRING};
}

@NameValuePairs = split (/&/, $QueryString);

foreach $NameValue (@NameValuePairs) {
  ($Name, $Value) = split (/=/, $NameValue);
  $Value =~ tr/+/ /;
  $Value =~ s/%([\dA-Fa-f][\dA-Fa-f])/ pack ("C",hex ($1))/eg;
  $Form{$Name} = $Value;
}

$user = $ENV{"REMOTE_USER"};
$BASE_DIR = "${BASE_DIR}${user}/";

# Split the path for the current category
@category_list = split (/\//, $Form{path});

# Read the global config file into Config_global
&parse_config_file ("$BASE_DIR$category_list[0].config", \%Config_global);

# Read the local config file into Config_local
&parse_config_file ("$BASE_DIR$Form{path}\/config", \%Config_local);

if ( $type eq "display_form" ) {

  dbmopen %ENTRIES, "$BASE_DIR$Form{path}\/entries", 0666;

# Display the form to edit an entry
  print "Content-type: text/html", "\n\n";
  print "<html><body>";
  print "<FORM ACTION=\"edit_entry.pl\" METHOD=\"POST\">";
  print "<INPUT TYPE=\"hidden\" NAME=\"path\" VALUE=\"$Form{path}\">";
  print "<INPUT TYPE=\"hidden\" NAME=\"entry_no\" VALUE=\"$Form{entry_no}\">";

  $i = $Form{"entry_no"};
  $j = 0;
  while ( $Config_global{"${j}_key"} ne "" ) {

    $key = $Config_global{"${j}_key"};
    $value_of_field = $ENTRIES{"${i}_$key"};

    if ($Config_global{"${j}_input"} ne "") {
        $value_of_field = eval "$Config_global{\"${j}_input\"}";
    }

    print "<BR><B>$Config_global{\"${j}_name\"} :</B> <BR>$Config_global{\"${j}_comment\"}<BR>";
    if ( $Config_global{"${j}_noneditable"} == 1) {
        print "<INPUT TYPE=\"hidden\" VALUE=\"$value_of_field\">$value_of_field<BR>";
    } else {
        if ( $Config_global{"${j}_type"} eq "textarea") {
            @size_list = split (/x/, $Config_global{"${j}_size"});
#            $key = $Config_global{"${j}_key"};
            print "<TEXTAREA NAME=\"$Config_global{\"${j}_key\"}\" ROWS=\"$size_list[0]\" COLS=\"$size_list[1]\">$value_of_field</TEXTAREA><BR>";
        } elsif ( $Config_global{"${j}_type"} eq "text") {
#            $key = $Config_global{"${j}_key"};
            print "<INPUT TYPE=\"text\" SIZE=\"$Config_global{\"${j}_size\"}\" NAME=\"$Config_global{\"${j}_key\"}\" VALUE=\"$value_of_field\"><BR>";
        } elsif ( $Config_global{"${j}_type"} eq "radio") {
#            $key = $Config_global{"${j}_key"};
            for ($l=1; $l <= $Config_global{"${j}_num_of_options"}; $l++) {
                $temp = $Config_global{"${j}_option_${l}"};
                if ( $value_of_field eq $temp ) {
                    print "<INPUT TYPE=\"radio\" NAME=\"$Config_global{\"${j}_key\"}\" VALUE=\"$temp\" CHECKED>$temp<BR>";
                } else {
                    print "<INPUT TYPE=\"radio\" NAME=\"$Config_global{\"${j}_key\"}\" VALUE=\"$temp\">$temp<BR>";
                }
            }
        } elsif ( $Config_global{"${j}_type"} eq "none") {
            print "$value_of_field<BR>";
            print "<INPUT TYPE=\"hidden\" NAME=\"$Config_global{\"${j}_key\"}\" VALUE =\"$value_of_field\">";
        }
    }
    $j++;
  }

  print "<BR><INPUT TYPE=\"submit\" NAME=\"Submit\">";

  dbmclose %ENTRIES;

} elsif ( $type eq "data_received" ) {

  dbmopen %ENTRIES, "$BASE_DIR$Form{path}\/entries", 0666;

# Lock the category
  $i = 0;
  while ($i < 5) {
    $i++;
    $result = &lock("$BASE_DIR$Form{path}");
    if ($result == 1) {
      $i = 5;
    } else {
      sleep(3);
    }
  }

# Just in case something went wrong and we were unable to lock the category
  if ($result == 0) {
    print "Content-type: text/html", "\n\n";
    print "<html><body>";
    print "<B>ERROR</B><BR>Unable to lock the category $Form{path}.";
    exit(0);
  }


# Put each entry into the database with the key as Form{entry_no} concantenated with the key got from the form, seperated by an _
  $i = $Form{"entry_no"};

  foreach $Form_key (keys %Form) {
      if ( ($Form_key ne "path") && ($Form_key ne "Submit") && ($Form_key ne "entry_no") ) {
          $ENTRIES_key = "${i}_$Form_key";
          $ENTRIES{"$ENTRIES_key"} = $Form{"$Form_key"};
      }
  }

  $ENTRIES{"${i}_USED"} = 1;

  dbmclose %ENTRIES;


# Unlock the category
  $i = 0;
  while ($i < 5) {
    $i++;
    $result = &unlock("$BASE_DIR$Form{path}");
    if ($result == 1) {
      $i = 5;
    } else {
      sleep(3);
    }
  }

# Just in case something went wrong and we were unable to unlock the category
  if ($result == 0) {
    print "Content-type: text/html", "\n\n";
    print "<html><body>";
    print "<B>ERROR</B><BR>Unable to unlock the category $Form{path}.";
    exit(0);
  }

# Display the category
  $the_path = $Form{path};
  $the_path =~ tr/ /+/;
  print "Location: display.pl?path=$the_path", "\n\n";

}

# Subroutine to unlock the category
sub unlock {

  ($_) = @_;

  $output = `rm \"$_\/lock\"`;
  if (open(LOCK, "$_\/lock")) {
    close(LOCK);
    return 0;
  }

  return 1;
}

# Subroutine to lock the category
sub lock {

  ($_) = @_;

  if (open(LOCK, "$_\/lock")) {
    $time_of_lock = <LOCK>;
    $time = time();
    if ($time - $time_of_lock < 900) {
      close(LOCK);
      return 0;
    }
    close(LOCK);
  }

  open(LOCK, ">$_\/lock");

  $time = time();
  print LOCK "$time";

  close(LOCK);

  return 1;

}



#subroutine to parse a config file and store it as a hash.
#Takes 2 arguments - the config file and a reference to the hash

sub parse_config_file {

local ($config_line, $Name, $Value, $Config);

$Config = $_[1];

if (!open (CONFIG, "$_[0]")) {
  print "<B>ERROR</B><BR>Config file not found : $category_list[0].config";
  exit(0);
}

while (<CONFIG>) {
    $config_line=$_;
    chop ($config_line);
    $config_line =~ s/^\s*//;
    $config_line =~ s/\s*$//;
    if ( ($config_line !~ /^#/) && ($config_line ne "") ){
        ($Name, $Value) = split (/=/, $config_line);
        $$Config{$Name} = $Value;
    }
}

close(CONFIG);

}


sub lastupdated_input {

    $username = $_[0];
    $date_time = `date`;
    $return_line = "$username on $date_time";
    chop ($return_line);
    return "$return_line";

}

